## tilemaker 2.0.0%2Bds

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Obtain and set version information from debian package
include /usr/share/dpkg/pkg-info.mk
TM_VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

export DEB_CXXFLAGS_MAINT_APPEND=-DTM_VERSION=$(TM_VERSION)

%:
	dh $@ --buildsystem=cmake

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/\-/\./g,\
filenamemangle=s/(?:.*?)?(?:rel|v|tilemaker)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/tilemaker-$1.$2/,\
repacksuffix=+ds \
https://github.com/systemed/tilemaker/tags \
(?:.*?/archive/(?:.*?/)?)?(?:rel|v|tilemaker)?[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## tilemaker 2.0.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

project(tilemaker)

OPTION(TILEMAKER_BUILD_STATIC "Attempt to link dependencies static" OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds are not allowed, please use a separate build directory.")
endif()

if (POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()

include_directories(include)
include_directories(${CMAKE_BINARY_DIR}) # for generated files

IF (TILEMAKER_BUILD_STATIC)
    MESSAGE (STATUS "Staticly linking with Boost")
    SET (Boost_USE_STATIC_LIBS TRUE)
	SET (CMAKE_FIND_LIBRARY_SUFFIXES ${CMAKE_STATIC_LIBRARY_SUFFIX})
ELSE ()
    MESSAGE (STATUS "Dynamically linking with Boost")
    SET (Boost_USE_STATIC_LIBS FALSE)
ENDIF ()

IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
ENDIF ()

find_package(Boost 1.66 REQUIRED COMPONENTS system filesystem program_options iostreams)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

find_package(Protobuf REQUIRED)
include_directories(${PROTOBUF_INCLUDE_DIR})

find_package(libshp REQUIRED)
include_directories(${LIBSHP_INCLUDE_DIR})

find_package(Lua)

if(LUA_FOUND)
	include_directories(${LUA_INCLUDE_DIR})
else()
	find_package(LuaJIT REQUIRED)
	add_definitions(-DLUAJIT)
	include_directories(${LUAJIT_INCLUDE_DIR})
endif()

find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIR})

set(CMAKE_CXX_STANDARD 14)

execute_process(
	COMMAND git describe --tags --abbrev=0
	OUTPUT_VARIABLE tm_version)
add_compile_definitions(TM_VERSION=${tm_version})

if(MSVC)
 	find_package(unofficial-sqlite3 CONFIG REQUIRED)
	add_definitions(-D_USE_MATH_DEFINES -DWIN32_LEAN_AND_MEAN -DNOGDI)
  	set(THREAD_LIB "")
else()
	find_package(SQLite3 REQUIRED)
	include_directories(${SQLITE3_INCLUDE_DIRS})
  	set(THREAD_LIB pthread)
endif()

ADD_CUSTOM_COMMAND(OUTPUT vector_tile.pb.cc vector_tile.pb.h
                   COMMAND ${PROTOBUF_PROTOC_EXECUTABLE}
		   ARGS --cpp_out ${CMAKE_BINARY_DIR} -I ${CMAKE_SOURCE_DIR}/include ${CMAKE_SOURCE_DIR}/include/vector_tile.proto)

ADD_CUSTOM_COMMAND(OUTPUT osmformat.pb.cc osmformat.pb.h
                   COMMAND ${PROTOBUF_PROTOC_EXECUTABLE}
		   ARGS --cpp_out ${CMAKE_BINARY_DIR} -I ${CMAKE_SOURCE_DIR}/include ${CMAKE_SOURCE_DIR}/include/osmformat.proto)

file(GLOB tilemaker_src_files
	src/attribute_store.cpp
	src/geom.cpp
	src/mbtiles.cpp
	src/osm_mem_tiles.cpp
	src/output_object.cpp
	src/read_pbf.cpp
	src/shared_data.cpp
	src/tile_data.cpp
	src/tile_worker.cpp
	src/coordinates.cpp
	src/helpers.cpp
	src/osm_lua_processing.cpp
	src/osm_store.cpp
	src/pbf_blocks.cpp
	src/read_shp.cpp
	src/shp_mem_tiles.cpp
	src/tilemaker.cpp
	src/write_geometry.cpp
  )
add_executable(tilemaker vector_tile.pb.cc osmformat.pb.cc ${tilemaker_src_files})
target_link_libraries(tilemaker ${PROTOBUF_LIBRARY} ${LIBSHP_LIBRARIES} ${SQLITE3_LIBRARIES} ${LUAJIT_LIBRARY} ${LUA_LIBRARIES} ${ZLIB_LIBRARY} ${THREAD_LIB} ${CMAKE_DL_LIBS}
	Boost::system Boost::filesystem Boost::program_options Boost::iostreams)

if(MSVC)
    target_link_libraries(tilemaker unofficial::sqlite3::sqlite3)
endif()

install(TARGETS tilemaker RUNTIME DESTINATION bin)

=== Makefile ===
# See what Lua versions are installed
# order of preference: LuaJIT 2.1, LuaJIT 2.0, any generic Lua, Lua 5.1

ifneq ("$(wildcard /usr/local/include/luajit-2.1/lua.h)","")
  LUA_VER := LuaJIT 2.1
  LUA_CFLAGS := -I/usr/local/include/luajit-2.1
  LUA_LIBS := -lluajit-5.1
  LUAJIT := 1

else ifneq ("$(wildcard /usr/include/luajit-2.1/lua.h)","")
  LUA_VER := LuaJIT 2.1
  LUA_CFLAGS := -I/usr/include/luajit-2.1
  LUA_LIBS := -lluajit-5.1
  LUAJIT := 1

else ifneq ("$(wildcard /usr/local/include/luajit-2.0/lua.h)","")
  LUA_VER := LuaJIT 2.0
  LUA_CFLAGS := -I/usr/local/include/luajit-2.0
  LUA_LIBS := -lluajit-5.1
  LUAJIT := 1

else ifneq ("$(wildcard /usr/include/luajit-2.0/lua.h)","")
  LUA_VER := LuaJIT 2.0
  LUA_CFLAGS := -I/usr/include/luajit-2.0
  LUA_LIBS := -lluajit-5.1
  LUAJIT := 1

else ifneq ("$(wildcard /usr/local/include/lua/lua.h)","")
  LUA_VER := system Lua
  LUA_CFLAGS := -I/usr/local/include/lua
  LUA_LIBS := -llua

else ifneq ("$(wildcard /usr/include/lua/lua.h)","")
  LUA_VER := system Lua
  LUA_CFLAGS := -I/usr/include/lua
  LUA_LIBS := -llua

else ifneq ("$(wildcard /usr/local/include/lua5.1/lua.h)","")
  LUA_VER := Lua 5.1
  LUA_CFLAGS := -I/usr/local/include/lua5.1
  LUA_LIBS := -llua5.1

else ifneq ("$(wildcard /usr/include/lua5.1/lua.h)","")
  LUA_VER := Lua 5.1
  LUA_CFLAGS := -I/usr/include/lua5.1
  LUA_LIBS := -llua5.1

else
  $(error Couldn't find Lua)
endif

$(info Using ${LUA_VER} (include path is ${LUA_CFLAGS}, library path is ${LUA_LIBS}))
ifneq ($(OS),Windows_NT)
  ifeq ($(shell uname -s), Darwin)
    ifeq ($(LUAJIT), 1)
      LDFLAGS := -pagezero_size 10000 -image_base 100000000
      $(info - with MacOS LuaJIT linking)
    endif
  endif
endif

# Main includes

TM_VERSION := $(shell git describe --tags --abbrev=0)
CXXFLAGS := -O3 -Wall -Wno-unknown-pragmas -Wno-sign-compare -std=c++14 -pthread -fPIE -DTM_VERSION=$(TM_VERSION) $(CONFIG)
LIB := -L/usr/local/lib -lz $(LUA_LIBS) -lboost_program_options -lsqlite3 -lboost_filesystem -lboost_system -lboost_iostreams -lprotobuf -lshp
INC := -I/usr/local/include -isystem ./include -I./src $(LUA_CFLAGS)

# Targets

all: tilemaker

tilemaker: include/osmformat.pb.o include/vector_tile.pb.o src/mbtiles.o src/pbf_blocks.o src/coordinates.o src/osm_store.o src/helpers.o src/output_object.o src/read_shp.o src/read_pbf.o src/osm_lua_processing.o src/write_geometry.o src/shared_data.o src/tile_worker.o src/tile_data.o src/osm_mem_tiles.o src/shp_mem_tiles.o src/attribute_store.o src/tilemaker.o src/geom.o
	$(CXX) $(CXXFLAGS) -o tilemaker $^ $(INC) $(LIB) $(LDFLAGS)

%.o: %.cpp
	$(CXX) $(CXXFLAGS) -o $@ -c $< $(INC)

%.o: %.cc
	$(CXX) $(CXXFLAGS) -o $@ -c $< $(INC)

%.pb.cc: %.proto
	protoc --proto_path=include --cpp_out=include $<

install:
	install -m 0755 tilemaker /usr/local/bin

clean:
	rm -f tilemaker src/*.o include/*.o

.PHONY: install

=== debian/changelog ===
tilemaker (2.0.0+ds-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Felix Delattre <debian@xama.nu>  Mon, 22 Nov 2021 16:52:50 +0000

tilemaker (2.0.0+ds-1~exp1) experimental; urgency=medium

  * Initial package (Closes: #993076)

 -- Felix Delattre <debian@xama.nu>  Wed, 08 Sep 2021 14:21:21 +0000

=== debian/control ===
Source: tilemaker
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Felix Delattre <debian@xama.nu>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               liblua5.1-dev,
               libprotobuf-dev,
               libshp-dev,
               libsqlite3-dev,
               pkg-config,
               protobuf-compiler,
               rapidjson-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/tilemaker
Vcs-Git: https://salsa.debian.org/debian-gis-team/tilemaker.git
Homepage: https://tilemaker.org/

Package: tilemaker
Section: utils
Architecture: any
Depends: shapelib,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Generates vector tiles from OpenStreetMap data
 tilemaker is a single executable command that takes OpenStreetMap data as
 planet or diff files and directly makes it into vector tiles.  It's
 supremely customisable, and if you just want off-the-shelf tiles in a
 standard style, tilemaker comes bundled with the configuration and process
 files to rely on the schema of OpenMapTiles by default.

## tilemaker 2.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,9 @@
 find_package(libshp REQUIRED)
 include_directories(${LIBSHP_INCLUDE_DIR})
 
+find_package(Rapidjson REQUIRED)
+include_directories(${RAPIDJSON_INCLUDEDIR})
+
 find_package(Lua)
 
 if(LUA_FOUND)
@@ -58,10 +61,12 @@
 
 set(CMAKE_CXX_STANDARD 14)
 
-execute_process(
-	COMMAND git describe --tags --abbrev=0
-	OUTPUT_VARIABLE tm_version)
-add_compile_definitions(TM_VERSION=${tm_version})
+if(!TM_VERSION)
+	execute_process(
+		COMMAND git describe --tags --abbrev=0
+		OUTPUT_VARIABLE tm_version)
+	add_compile_definitions(TM_VERSION=${tm_version})
+endif()
 
 if(MSVC)
  	find_package(unofficial-sqlite3 CONFIG REQUIRED)

=== Makefile ===
--- 
+++ 
@@ -1,27 +1,29 @@
 # See what Lua versions are installed
 # order of preference: LuaJIT 2.1, LuaJIT 2.0, any generic Lua, Lua 5.1
 
+PLATFORM_PATH := /usr/local
+
 ifneq ("$(wildcard /usr/local/include/luajit-2.1/lua.h)","")
   LUA_VER := LuaJIT 2.1
-  LUA_CFLAGS := -I/usr/local/include/luajit-2.1
+  LUA_CFLAGS := -I/usr/local/include/luajit-2.1 -DLUAJIT
   LUA_LIBS := -lluajit-5.1
   LUAJIT := 1
 
 else ifneq ("$(wildcard /usr/include/luajit-2.1/lua.h)","")
   LUA_VER := LuaJIT 2.1
-  LUA_CFLAGS := -I/usr/include/luajit-2.1
+  LUA_CFLAGS := -I/usr/include/luajit-2.1 -DLUAJIT
   LUA_LIBS := -lluajit-5.1
   LUAJIT := 1
 
 else ifneq ("$(wildcard /usr/local/include/luajit-2.0/lua.h)","")
   LUA_VER := LuaJIT 2.0
-  LUA_CFLAGS := -I/usr/local/include/luajit-2.0
+  LUA_CFLAGS := -I/usr/local/include/luajit-2.0 -DLUAJIT
   LUA_LIBS := -lluajit-5.1
   LUAJIT := 1
 
 else ifneq ("$(wildcard /usr/include/luajit-2.0/lua.h)","")
   LUA_VER := LuaJIT 2.0
-  LUA_CFLAGS := -I/usr/include/luajit-2.0
+  LUA_CFLAGS := -I/usr/include/luajit-2.0 -DLUAJIT
   LUA_LIBS := -lluajit-5.1
   LUAJIT := 1
 
@@ -35,6 +37,11 @@
   LUA_CFLAGS := -I/usr/include/lua
   LUA_LIBS := -llua
 
+else ifneq ("$(wildcard /usr/include/lua.h)","")
+  LUA_VER := system Lua
+  LUA_CFLAGS := -I/usr/include
+  LUA_LIBS := -llua
+
 else ifneq ("$(wildcard /usr/local/include/lua5.1/lua.h)","")
   LUA_VER := Lua 5.1
   LUA_CFLAGS := -I/usr/local/include/lua5.1
@@ -44,6 +51,12 @@
   LUA_VER := Lua 5.1
   LUA_CFLAGS := -I/usr/include/lua5.1
   LUA_LIBS := -llua5.1
+
+else ifneq ("$(wildcard /opt/homebrew/include/lua5.1/lua.h)","")
+  LUA_VER := Lua 5.1
+  LUA_CFLAGS := -I/opt/homebrew/include/lua5.1
+  LUA_LIBS := -llua5.1
+  PLATFORM_PATH := /opt/homebrew
 
 else
   $(error Couldn't find Lua)
@@ -61,10 +74,13 @@
 
 # Main includes
 
-TM_VERSION := $(shell git describe --tags --abbrev=0)
-CXXFLAGS := -O3 -Wall -Wno-unknown-pragmas -Wno-sign-compare -std=c++14 -pthread -fPIE -DTM_VERSION=$(TM_VERSION) $(CONFIG)
-LIB := -L/usr/local/lib -lz $(LUA_LIBS) -lboost_program_options -lsqlite3 -lboost_filesystem -lboost_system -lboost_iostreams -lprotobuf -lshp
-INC := -I/usr/local/include -isystem ./include -I./src $(LUA_CFLAGS)
+prefix = /usr/local
+
+MANPREFIX := /usr/share/man
+TM_VERSION ?= $(shell git describe --tags --abbrev=0)
+CXXFLAGS ?= -O3 -Wall -Wno-unknown-pragmas -Wno-sign-compare -std=c++14 -pthread -fPIE -DTM_VERSION=$(TM_VERSION) $(CONFIG)
+LIB := -L$(PLATFORM_PATH)/lib -lz $(LUA_LIBS) -lboost_program_options -lsqlite3 -lboost_filesystem -lboost_system -lboost_iostreams -lprotobuf -lshp -pthread
+INC := -I$(PLATFORM_PATH)/include -isystem ./include -I./src $(LUA_CFLAGS)
 
 # Targets
 
@@ -83,9 +99,12 @@
 	protoc --proto_path=include --cpp_out=include $<
 
 install:
-	install -m 0755 tilemaker /usr/local/bin
+	install -m 0755 -d $(DESTDIR)$(prefix)/bin/
+	install -m 0755 tilemaker $(DESTDIR)$(prefix)/bin/
+	install -d ${DESTDIR}${MANPREFIX}/man1/
+	-install docs/man/tilemaker.1 ${DESTDIR}${MANPREFIX}/man1/
 
 clean:
-	rm -f tilemaker src/*.o include/*.o
+	rm -f tilemaker src/*.o include/*.o include/*.pb.h
 
 .PHONY: install

=== debian/changelog ===
tilemaker (2.2.0-2) unstable; urgency=medium

  * Added patch to include latomic flag when needed.

 -- Felix Delattre <debian@xama.nu>  Tue, 09 Aug 2022 16:08:02 +0000

tilemaker (2.2.0-1) unstable; urgency=medium

  [ Felix Delattre ]
  * New upstream release 2.2.0.
  * Updated patches.

  [ Bas Couwenberg ]
  * Bump Standards-Version to 4.6.1, no changes.

 -- Felix Delattre <debian@xama.nu>  Wed, 03 Aug 2022 08:20:20 +0000

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
                pkg-config,
                protobuf-compiler,
                rapidjson-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/tilemaker
 Vcs-Git: https://salsa.debian.org/debian-gis-team/tilemaker.git
 Homepage: https://tilemaker.org/

## tilemaker 2.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -110,8 +110,16 @@
 target_link_libraries(tilemaker ${PROTOBUF_LIBRARY} ${LIBSHP_LIBRARIES} ${SQLITE3_LIBRARIES} ${LUAJIT_LIBRARY} ${LUA_LIBRARIES} ${ZLIB_LIBRARY} ${THREAD_LIB} ${CMAKE_DL_LIBS}
 	Boost::system Boost::filesystem Boost::program_options Boost::iostreams)
 
+include(CheckCxxAtomic)
+if(NOT HAVE_CXX11_ATOMIC)
+	string(APPEND CMAKE_CXX_STANDARD_LIBRARIES
+	" ${LIBATOMIC_LINK_FLAGS}")
+endif()
+
 if(MSVC)
     target_link_libraries(tilemaker unofficial::sqlite3::sqlite3)
 endif()
 
+install(FILES docs/man/tilemaker.1 DESTINATION share/man/man1)
+
 install(TARGETS tilemaker RUNTIME DESTINATION bin)

=== Makefile ===
--- 
+++ 
@@ -101,8 +101,8 @@
 install:
 	install -m 0755 -d $(DESTDIR)$(prefix)/bin/
 	install -m 0755 tilemaker $(DESTDIR)$(prefix)/bin/
-	install -d ${DESTDIR}${MANPREFIX}/man1/
-	-install docs/man/tilemaker.1 ${DESTDIR}${MANPREFIX}/man1/
+	install -m 0755 -d ${DESTDIR}${MANPREFIX}/man1/
+	install docs/man/tilemaker.1 ${DESTDIR}${MANPREFIX}/man1/
 
 clean:
 	rm -f tilemaker src/*.o include/*.o include/*.pb.h

=== debian/changelog ===
tilemaker (2.4.0-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:26:55 +1100

tilemaker (2.4.0-1build3) noble; urgency=high

  * No change rebuild against libprotobuf32t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:57:08 +0100

tilemaker (2.4.0-1build2) noble; urgency=medium

  * Rebuild against latest shapelib

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 18 Feb 2024 14:43:37 -0500

tilemaker (2.4.0-1build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:56:57 +0100

tilemaker (2.4.0-1) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Add Rules-Requires-Root to control file.
  * Bump Standards-Version to 4.6.2, no changes.
  * Bump debhelper compat to 13.

  [ Felix Delattre ]
  * New upstream release.
  * Remove obsolete patches.
  * Updated year for copyright information.

 -- Felix Delattre <debian@xama.nu>  Sat, 01 Jul 2023 16:00:42 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: tilemaker
-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Felix Delattre <debian@xama.nu>
 Section: science
 Priority: optional
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libboost-dev,
                libboost-filesystem-dev,
                libboost-iostreams-dev,
@@ -17,10 +18,11 @@
                pkg-config,
                protobuf-compiler,
                rapidjson-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/tilemaker
 Vcs-Git: https://salsa.debian.org/debian-gis-team/tilemaker.git
 Homepage: https://tilemaker.org/
+Rules-Requires-Root: no
 
 Package: tilemaker
 Section: utils

## tilemaker 3.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

project(tilemaker)

OPTION(TILEMAKER_BUILD_STATIC "Attempt to link dependencies static" OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds are not allowed, please use a separate build directory.")
endif()

if (POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()

IF (TILEMAKER_BUILD_STATIC)
    MESSAGE (STATUS "Staticly linking with Boost")
    SET (Boost_USE_STATIC_LIBS TRUE)
	SET (CMAKE_FIND_LIBRARY_SUFFIXES ${CMAKE_STATIC_LIBRARY_SUFFIX})
ELSE ()
    MESSAGE (STATUS "Dynamically linking with Boost")
    SET (Boost_USE_STATIC_LIBS FALSE)
ENDIF ()

IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
ENDIF ()

find_package(Boost 1.66 REQUIRED COMPONENTS system filesystem program_options iostreams)

find_package(libshp REQUIRED)

find_package(Rapidjson REQUIRED)

find_package(Lua)

if(LUA_FOUND)
	include_directories(${LUA_INCLUDE_DIR})
else()
	find_package(LuaJIT REQUIRED)
	add_definitions(-DLUAJIT)
	include_directories(${LUAJIT_INCLUDE_DIR})
endif()

find_package(ZLIB REQUIRED)

set(CMAKE_CXX_STANDARD 17)

if(!TM_VERSION)
	execute_process(
		COMMAND git describe --tags --abbrev=0
		OUTPUT_VARIABLE tm_version)
	add_compile_definitions(TM_VERSION=${tm_version})
endif()

if(MSVC)
 	find_package(unofficial-sqlite3 CONFIG REQUIRED)
	add_library(SQLite::SQLite3 ALIAS unofficial::sqlite3::sqlite3)
	add_definitions(-D_USE_MATH_DEFINES -DWIN32_LEAN_AND_MEAN -DNOGDI -D__restrict__=__restrict)
  	set(THREAD_LIB "")
else()
	find_package(SQLite3 REQUIRED)
  	set(THREAD_LIB pthread)
endif()

file(GLOB tilemaker_src_files
	src/attribute_store.cpp
	src/coordinates.cpp
	src/coordinates_geom.cpp
	src/external/streamvbyte_decode.c
	src/external/streamvbyte_encode.c
	src/external/streamvbyte_zigzag.c
	src/geojson_processor.cpp
	src/geom.cpp
	src/helpers.cpp
	src/mbtiles.cpp
	src/mmap_allocator.cpp
	src/node_stores.cpp
	src/options_parser.cpp
	src/osm_lua_processing.cpp
	src/osm_mem_tiles.cpp
	src/osm_store.cpp
	src/output_object.cpp
	src/pbf_processor.cpp
	src/pbf_reader.cpp
	src/pmtiles.cpp
	src/pooled_string.cpp
	src/relation_roles.cpp
	src/sharded_node_store.cpp
	src/sharded_way_store.cpp
	src/shared_data.cpp
	src/shp_mem_tiles.cpp
	src/shp_processor.cpp
	src/significant_tags.cpp
	src/sorted_node_store.cpp
	src/sorted_way_store.cpp
	src/tag_map.cpp
	src/tile_data.cpp
	src/tilemaker.cpp
	src/tile_worker.cpp
	src/way_stores.cpp
  )
add_executable(tilemaker ${tilemaker_src_files})
target_include_directories(tilemaker PRIVATE include)
target_include_directories(tilemaker PRIVATE ${CMAKE_BINARY_DIR}) # for generated files
target_link_libraries(tilemaker
		${THREAD_LIB} ${CMAKE_DL_LIBS}
		${LUA_LIBRARIES}
		shapelib::shp
		SQLite::SQLite3
		ZLIB::ZLIB
		Rapidjson::rapidjson
		Boost::system Boost::filesystem Boost::program_options Boost::iostreams)

include(CheckCxxAtomic)
if(NOT HAVE_CXX11_ATOMIC)
	string(APPEND CMAKE_CXX_STANDARD_LIBRARIES
	" ${LIBATOMIC_LINK_FLAGS}")
endif()

install(FILES docs/man/tilemaker.1 DESTINATION share/man/man1)

add_executable(tilemaker-server server/server.cpp)
target_include_directories(tilemaker-server PRIVATE include)
target_link_libraries(tilemaker-server ${THREAD_LIB} ${CMAKE_DL_LIBS} SQLite::SQLite3 Boost::filesystem Boost::program_options)

install(TARGETS tilemaker tilemaker-server RUNTIME DESTINATION bin)

=== Makefile ===
# See what Lua versions are installed
# order of preference: LuaJIT, any generic Lua, then versions from 5.4 down

PLATFORM_PATH := /usr/local

# First, find what the Lua executable is called
# - when a new Lua is released, then add it before 5.4 here
LUA_CMD := $(shell luajit -e 'print("luajit")' 2> /dev/null || lua -e 'print("lua")' 2> /dev/null || lua5.4 -e 'print("lua5.4")' 2> /dev/null || lua5.3 -e 'print("lua5.3")' 2> /dev/null || lua5.2 -e 'print("lua5.2")' 2> /dev/null || lua5.1 -e 'print("lua5.1")' 2> /dev/null)
ifeq ($(LUA_CMD),"")
  $(error Couldn't find Lua interpreter)
endif
$(info Using ${LUA_CMD})

# Find the language version
LUA_LANGV := $(shell ${LUA_CMD} -e 'print(string.match(_VERSION, "%d+.%d+"))')
$(info - Lua language version ${LUA_LANGV})

# Find the directory where Lua might be
ifeq ($(LUA_CMD),luajit)
  # We need the LuaJIT version (2.0/2.1) to find this
  LUA_JITV := $(shell luajit -e 'a,b,c=string.find(jit.version,"LuaJIT (%d.%d)");print(c)')
  $(info - LuaJIT version ${LUA_JITV})
  LUA_DIR := luajit-${LUA_JITV}
  LUA_LIBS := -lluajit-${LUA_LANGV}
else
  LUA_DIR := $(LUA_CMD)
  LUA_LIBS := -l${LUA_CMD}
endif

# Find the include path by looking in the most likely locations
ifneq ('$(wildcard /usr/local/include/${LUA_DIR}/lua.h)','')
  LUA_CFLAGS := -I/usr/local/include/${LUA_DIR}
else ifneq ('$(wildcard /usr/local/include/${LUA_DIR}${LUA_LANGV}/lua.h)','')
  LUA_CFLAGS := -I/usr/local/include/${LUA_DIR}${LUA_LANGV}
  LUA_LIBS := -l${LUA_CMD}${LUA_LANGV}
else ifneq ('$(wildcard /usr/include/${LUA_DIR}/lua.h)','')
  LUA_CFLAGS := -I/usr/include/${LUA_DIR}
else ifneq ('$(wildcard /usr/include/${LUA_DIR}${LUA_LANGV}/lua.h)','')
  LUA_CFLAGS := -I/usr/include/${LUA_DIR}${LUA_LANGV}
  LUA_LIBS := -l${LUA_CMD}${LUA_LANGV}
else ifneq ('$(wildcard /usr/include/lua.h)','')
  LUA_CFLAGS := -I/usr/include
else ifneq ('$(wildcard /opt/homebrew/include/${LUA_DIR}/lua.h)','')
  LUA_CFLAGS := -I/opt/homebrew/include/${LUA_DIR}
  PLATFORM_PATH := /opt/homebrew
else ifneq ('$(wildcard /opt/homebrew/include/${LUA_DIR}${LUA_LANGV}/lua.h)','')
  LUA_CFLAGS := -I/opt/homebrew/include/${LUA_DIR}${LUA_LANGV}
  LUA_LIBS := -l${LUA_CMD}${LUA_LANGV}
  PLATFORM_PATH := /opt/homebrew
else
  $(error Couldn't find Lua libraries)
endif

# Append LuaJIT-specific flags if needed
ifeq ($(LUA_CMD),luajit)
  LUA_CFLAGS := ${LUA_CFLAGS} -DLUAJIT
  ifneq ($(OS),Windows_NT)
    ifeq ($(shell uname -s), Darwin)
      LDFLAGS := -pagezero_size 10000 -image_base 100000000
      $(info - with MacOS LuaJIT linking)
    endif
  endif
endif

# Report success
$(info - include path is ${LUA_CFLAGS})
$(info - library path is ${LUA_LIBS})

# Main includes

prefix = /usr/local

MANPREFIX := /usr/share/man
TM_VERSION ?= $(shell git describe --tags --abbrev=0)
CXXFLAGS ?= -O3 -Wall -Wno-unknown-pragmas -Wno-sign-compare -std=c++14 -pthread -fPIE -DTM_VERSION=$(TM_VERSION) $(CONFIG)
CFLAGS ?= -O3 -Wall -Wno-unknown-pragmas -Wno-sign-compare -std=c99 -fPIE -DTM_VERSION=$(TM_VERSION) $(CONFIG)
LIB := -L$(PLATFORM_PATH)/lib -lz $(LUA_LIBS) -lboost_program_options -lsqlite3 -lboost_filesystem -lboost_system -lboost_iostreams -lshp -pthread
INC := -I$(PLATFORM_PATH)/include -isystem ./include -I./src $(LUA_CFLAGS)

# Targets
.PHONY: test

all: tilemaker server

tilemaker: \
	src/attribute_store.o \
	src/coordinates_geom.o \
	src/coordinates.o \
	src/external/streamvbyte_decode.o \
	src/external/streamvbyte_encode.o \
	src/external/streamvbyte_zigzag.o \
	src/geojson_processor.o \
	src/geom.o \
	src/helpers.o \
	src/mbtiles.o \
	src/mmap_allocator.o \
	src/node_stores.o \
	src/options_parser.o \
	src/osm_lua_processing.o \
	src/osm_mem_tiles.o \
	src/osm_store.o \
	src/output_object.o \
	src/pbf_processor.o \
	src/pbf_reader.o \
	src/pmtiles.o \
	src/pooled_string.o \
	src/relation_roles.o \
	src/sharded_node_store.o \
	src/sharded_way_store.o \
	src/shared_data.o \
	src/shp_mem_tiles.o \
	src/shp_processor.o \
	src/significant_tags.o \
	src/sorted_node_store.o \
	src/sorted_way_store.o \
	src/tag_map.o \
	src/tile_data.o \
	src/tilemaker.o \
	src/tile_worker.o \
	src/way_stores.o
	$(CXX) $(CXXFLAGS) -o tilemaker $^ $(INC) $(LIB) $(LDFLAGS)

test: \
	test_append_vector \
	test_attribute_store \
	test_deque_map \
	test_pbf_reader \
	test_pooled_string \
	test_relation_roles \
	test_significant_tags \
	test_sorted_node_store \
	test_sorted_way_store

test_append_vector: \
	src/mmap_allocator.o \
	test/append_vector.test.o
	$(CXX) $(CXXFLAGS) -o test.append_vector $^ $(INC) $(LIB) $(LDFLAGS) && ./test.append_vector

test_attribute_store: \
	src/mmap_allocator.o \
	src/attribute_store.o \
	src/pooled_string.o \
	test/attribute_store.test.o
	$(CXX) $(CXXFLAGS) -o test.attribute_store $^ $(INC) $(LIB) $(LDFLAGS) && ./test.attribute_store

test_deque_map: \
	test/deque_map.test.o
	$(CXX) $(CXXFLAGS) -o test.deque_map $^ $(INC) $(LIB) $(LDFLAGS) && ./test.deque_map

test_options_parser: \
	src/options_parser.o \
	test/options_parser.test.o
	$(CXX) $(CXXFLAGS) -o test.options_parser $^ $(INC) $(LIB) $(LDFLAGS) && ./test.options_parser

test_pooled_string: \
	src/mmap_allocator.o \
	src/pooled_string.o \
	test/pooled_string.test.o
	$(CXX) $(CXXFLAGS) -o test.pooled_string $^ $(INC) $(LIB) $(LDFLAGS) && ./test.pooled_string


test_relation_roles: \
	src/relation_roles.o \
	test/relation_roles.test.o
	$(CXX) $(CXXFLAGS) -o test.relation_roles $^ $(INC) $(LIB) $(LDFLAGS) && ./test.relation_roles

test_significant_tags: \
	src/significant_tags.o \
	src/tag_map.o \
	test/significant_tags.test.o
	$(CXX) $(CXXFLAGS) -o test.significant_tags $^ $(INC) $(LIB) $(LDFLAGS) && ./test.significant_tags

test_sorted_node_store: \
	src/external/streamvbyte_decode.o \
	src/external/streamvbyte_encode.o \
	src/external/streamvbyte_zigzag.o \
	src/mmap_allocator.o \
	src/sorted_node_store.o \
	test/sorted_node_store.test.o
	$(CXX) $(CXXFLAGS) -o test.sorted_node_store $^ $(INC) $(LIB) $(LDFLAGS) && ./test.sorted_node_store

test_sorted_way_store: \
	src/external/streamvbyte_decode.o \
	src/external/streamvbyte_encode.o \
	src/external/streamvbyte_zigzag.o \
	src/mmap_allocator.o \
	src/sorted_way_store.o \
	test/sorted_way_store.test.o
	$(CXX) $(CXXFLAGS) -o test.sorted_way_store $^ $(INC) $(LIB) $(LDFLAGS) && ./test.sorted_way_store

test_pbf_reader: \
	src/helpers.o \
	src/pbf_reader.o \
	test/pbf_reader.test.o
	$(CXX) $(CXXFLAGS) -o test.pbf_reader $^ $(INC) $(LIB) $(LDFLAGS) && ./test.pbf_reader

server: \
	server/server.o 
	$(CXX) $(CXXFLAGS) -o tilemaker-server $^ $(INC) $(LIB) $(LDFLAGS)

%.o: %.cpp
	$(CXX) $(CXXFLAGS) -o $@ -c $< $(INC)

%.o: %.c
	$(CC) $(CFLAGS) -o $@ -c $< $(INC)

install:
	install -m 0755 -d $(DESTDIR)$(prefix)/bin/
	install -m 0755 tilemaker $(DESTDIR)$(prefix)/bin/
	install -m 0755 tilemaker-server $(DESTDIR)$(prefix)/bin/
	@install -m 0755 -d ${DESTDIR}${MANPREFIX}/man1/ || true
	@install docs/man/tilemaker.1 ${DESTDIR}${MANPREFIX}/man1/ || true

clean:
	rm -f tilemaker tilemaker-server src/*.o src/external/*.o include/*.o include/*.pb.h server/*.o test/*.o

.PHONY: install

=== debian/changelog ===
tilemaker (3.0.0-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:28:27 +0200

tilemaker (3.0.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Enable Salsa CI.
  * Replace pkg-config build dependency with pkgconf.
  * Update copyright file.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 16 Mar 2024 12:12:29 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: tilemaker
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Felix Delattre <debian@xama.nu>
 Section: science
 Priority: optional
@@ -15,7 +14,7 @@
                libprotobuf-dev,
                libshp-dev,
                libsqlite3-dev,
-               pkg-config,
+               pkgconf,
                protobuf-compiler,
                rapidjson-dev
 Standards-Version: 4.6.2
